#!/usr/local/bin/python

import sys
import os
# fix symbolic link
#sys.path.insert(0,os.path.dirname(os.path.abspath(sys.argv[0])))

def usage():
    print 'btqueue.py [scheduler|crawler|query|add] [args...]'
    sys.exit()

if __name__ == '__main__':
    if len(sys.argv) == 1:
        usage()

    command = sys.argv[1]

    if sys.platform == 'win32' or not os.environ.get('HOME'):
        root_path = os.path.dirname(os.path.abspath(sys.argv[0]))
    else:
        root_path = os.path.join(os.environ.get('HOME'),'.btqueue')

    if len(sys.argv) == 3:
        root_path = sys.argv[2]

    from BitQueue import policy
    pol = policy.Policy(root_path)
    pol.set_default()

    if command == 'scheduler':
        from BitQueue.manager import Console
        app = Console()
        try:
            app.mainloop()
        except Exception,why:
            print why
    elif command == 'crawler':
        from BitCrawler.crawler import Crawler
        app = Crawler()
        app.process()
    else:
        from BitQueue.webservice import WebInterface
        app = WebInterface()
        from BitQueue import timeoutsocket
        timeoutsocket.setDefaultSocketTimeout(2)
        ret = app.process(command,sys.argv[2:])
        timeoutsocket.setDefaultSocketTimeout(None)
        if ret:
            if command == 'add' and \
               ret.find('timeout') >= 0 and \
               sys.platform == 'win32':
                from BitQueue.manager import Console
                app = Console()
                app.do_add(' '.join(sys.argv[2:]))
                app.mainloop()
            else:
                print ret
                if command == 'add' and sys.platform == 'win32':
                    raw_input()
